<?php

namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\FindService;
use SM\Traits\TResponse;

class FindController extends SMCrud
{
    use TResponse;
    protected $FindService;

    public function __construct($crudService, $environment, FindService $FindService)
    {
        parent::__construct($crudService, $environment);
        $this->FindService = $FindService;
    }

    public function findContrato(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findContrato($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findEscopoFaturamento(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findEscopoFaturamento($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findModeloContrato(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloContrato($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findHabilidades(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findHabilidades($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findParceiroNegocio(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findParceiroNegocio($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperadorHierarquia(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperadorHierarquia($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
  
    public function findIdioma(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findIdioma($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findMoeda(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findMoeda($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findProposta(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findProposta($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findModeloProposta(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloProposta($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findCentroCusto(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findCentroCusto($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findServico(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findServico($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findOperador(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findOperador($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findPerfilAcesso(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findPerfilAcesso($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function findTipoMedida(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findTipoMedida($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function findModeloDocumento(Request $request)
    {
        try {
            $filtro = $this->getFiltro($request);
            $data = $this->FindService->findModeloDocumento($filtro);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getFiltro($request)
    {
        if (isset($request->getParameters()["find"])) {
            $filtro = $request->getParameters()["find"];
        } else {
            $filtro = '';
        }
        return $filtro;
    }
}
