<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00049AgrupamentoDeContratosFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getInformacoesGridPrincipal()
    {

        $sql = "SELECT
                    PARC.NMPRINCIPALPARC,
                    PARC.NMSECUNDARIPARC,
                    PARC.NRPARCNEGOCIO,
                    AGRUP.NRPARCFATURA,
                    AGRUP.NRAGRUPAMENTO,
                    AGRUP.NMAGRUPAMENTO,
                    AGRUP.DSOBSAGRUPAMENTO,
                    AGRUP.NRORG,
                    AGRUP.IDATIVO,
                    AGRUP.DTINCLUSAO,
                    AGRUP.DTULTATU,
                    AGRUP.NRORGINCLUSAO,
                    AGRUP.CDOPERINCLUSAO,
                    AGRUP.NRORGULTATU,
                    AGRUP.CDOPERULTATU,
                    AGRUP.CDFILIAL,
                    FILIAL.NMFILIAL,
                    AGRUP.CDTIPOOPERFATURA,
                    AGRUP.CDSERIENF,
                    AGRUP.CDEMPRESA,
                    AGRUP.CDINSCESTA,
                    AGRUP.CDINSCMUNI,
                    TPOPER.NMTIPOOPER,
                    SERIENF.DSSERIE,
                    (SELECT LISTAGG(NMTIPOORCAMENTO, ', ')
                        WITHIN GROUP ( ORDER BY NMTIPOORCAMENTO)
                                FROM FCT_RELACESCOPOAGRUPAMENTO ESCAGRUP
                                JOIN FCT_TIPOORCAMENTO ESC
                                ON ESCAGRUP.NRTIPOORCAMENTO = ESC.NRTIPOORCAMENTO
                                AND ESCAGRUP.NRORG = ESC.NRORG
                            WHERE ESCAGRUP.NRAGRUPAMENTO = AGRUP.NRAGRUPAMENTO) AS NMTIPOORCAMENTO,
                    (SELECT LISTAGG(NRTIPOORCAMENTO, ',')
                        WITHIN GROUP ( ORDER BY NRTIPOORCAMENTO)
                                FROM FCT_RELACESCOPOAGRUPAMENTO ESCAGRUP
                            WHERE ESCAGRUP.NRAGRUPAMENTO = AGRUP.NRAGRUPAMENTO) AS NRTIPOORCAMENTO
                                FROM FCT_AGRUPAMENTO AGRUP
                        LEFT JOIN FILIAL
                                ON AGRUP.CDFILIAL = FILIAL.CDFILIAL
                                AND AGRUP.NRORG = FILIAL.NRORG
                        LEFT JOIN PARCNEGOCIO PARC
                                ON AGRUP.NRPARCFATURA = PARC.NRPARCNEGOCIO
                                AND AGRUP.NRORG = PARC.NRORG
                        LEFT JOIN TIPOOPERAC TPOPER
                                ON AGRUP.CDTIPOOPERFATURA = TPOPER.CDTIPOOPER
                                AND AGRUP.NRORG = TPOPER.NRORG
                                AND IDENTRSAIDOP = 'S'
                        LEFT JOIN SERIENF
                                ON AGRUP.CDSERIENF = SERIENF.CDSERIE
                                AND AGRUP.NRORG = SERIENF.NRORG
                                AND AGRUP.CDINSCESTA = SERIENF.CDINSCESTA
                                AND AGRUP.CDINSCMUNI = SERIENF.CDINSCMUNI";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getParceirosDeNegocio($parametros)
    {
        $tipoParceiro = $parametros['CDTIPOPARCEIRO'];
        $operador     = $parametros['CDOPERADOR'];

        $sql = "SELECT DISTINCT PARCNEGOCIO.*,
                    OPERADOR.NMOPERADOR AS NMOPERRESPONSAVEL
                    FROM PARCNEGOCIO
                    LEFT JOIN PARCERIA
                    ON PARCNEGOCIO.NRPARCNEGOCIO = PARCERIA.NRPARCNEGOCIO
                    AND PARCNEGOCIO.NRORG = PARCERIA.NRORG
                    LEFT JOIN OPERADOR
                    ON PARCNEGOCIO.CDOPERRESPONSAVEL = OPERADOR.CDOPERADOR
                    AND PARCNEGOCIO.NRORG = OPERADOR.NRORG
                    LEFT JOIN (SELECT *
                                FROM CRM_HIERARQUIAOPER
                                WHERE CDOPERADOR = '$operador') OPERHIERAR
                    ON OPERHIERAR.NRORG = PARCNEGOCIO.NRORG
                    LEFT JOIN FCT_PARAMETROGERAL
                PARAM ON PARCNEGOCIO.NRORG = PARAM.NRORG
                WHERE (PARCERIA.CDTIPOPARCEIRO IN ($tipoParceiro)
                    AND PARCERIA.IDATIVO = 'S'
                    AND PARCNEGOCIO.IDATIVO = 'S')
                    AND ((PARAM.IDUTILIZAHIEROPER = 'S'
                    AND (PARCNEGOCIO.CDOPERRESPONSAVEL IN (SELECT CDOPERADOR
                                                                FROM CRM_HIERARQUIAOPER
                                                                WHERE (CRM_HIERARQUIAOPER.CDFILIAL = OPERHIERAR.CDFILIAL
                                                                    OR CRM_HIERARQUIAOPER.CDFILIAL IS NULL)
                CONNECT BY PRIOR CRM_HIERARQUIAOPER.NRHIERARQUIAOPER = CRM_HIERARQUIAOPER.NRHIERARQUIAPAI
                START WITH CRM_HIERARQUIAOPER.CDOPERADOR = OPERHIERAR.CDOPERADOR ))
                    OR PARCNEGOCIO.CDOPERRESPONSAVEL IS NULL)
                    OR (OPERHIERAR.IDOPERMASTER = 'S')
                    OR (PARAM.IDUTILIZAHIEROPER = 'N'))
                    ORDER BY PARCNEGOCIO.NRPARCNEGOCIO";

            return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEscoposFaturamento()
    {

        $sql = "SELECT
                    TIPO.NRTIPOORCAMENTO,
                    TIPO.NMTIPOORCAMENTO,
                    TIPO.NRORG,
                    TIPO.IDATIVO,
                    TIPO.IDFATURAORCA,
                    TIPO.IDAPURAFATUR,
                    TIPO.NRGRUPFATADIC,
                    TIPO.NRGRUPFATSERV,
                    TIPO.CDPRECBASEVEND,
                    TIPO.CDMINEMORCA,
                    TIPO.CDPRECBASESERV,
                    TIPO.DTINCLUSAO,
                    TIPO.DTULTATU,
                    TIPO.NRORGINCLUSAO,
                    TIPO.CDOPERINCLUSAO,
                    TIPO.NRORGULTATU,
                    TIPO.CDOPERULTATU,
                    MODC.NMMODCONTRATO,
                    GRUF.NMGRUPOFATURA,
                    PRECOBASE.DSPRECOBASE,
                    PBS.DSPRECBASESERV,
                    INC.NMOPERADOR AS NMOPERINCLUSAO,
                    ALT.NMOPERADOR AS NMOPERULTATU,
                    TIPO.IDUTILIZAVARPRECO,
                    TIPO.IDALTQTDMEDIDAPROP,
                    TIPO.IDALTVRTABRPECPROP,
                    TIPO.IDTIPOORCA,
                    TIPO.IDFILTRASERVICO,
                    NVL((SELECT DISTINCT 'S'
                            FROM FCT_RELACESCOPOAGRUPAMENTO
                            WHERE NRTIPOORCAMENTO = TIPO.NRTIPOORCAMENTO
                            AND NRORG = TIPO.NRORG), 'N') AS ESCOPOAGRUPADO
                        FROM FCT_TIPOORCAMENTO TIPO
                    LEFT JOIN FCT_MODELOCONTRATO MODC
                        ON TIPO.NRSEQMODCONTRATO = MODC.NRSEQMODCONTRA
                        AND TIPO.NRORG = MODC.NRORG
                    LEFT JOIN FCT_GRUPOFATURA GRUF
                        ON TIPO.NRGRUPFATSERV = GRUF.NRGRUPOFATURA
                        AND TIPO.NRORG = GRUF.NRORG
                    LEFT JOIN PRECOBASE
                        ON TIPO.CDPRECBASEVEND = PRECOBASE.CDPRECOBASE
                        AND TIPO.NRORG = PRECOBASE.NRORG
                    LEFT JOIN FCT_PRECBASESERV PBS
                        ON TIPO.CDPRECBASESERV = PBS.CDPRECBASESERV
                        AND TIPO.NRORG = PBS.NRORG
                    LEFT JOIN OPERADOR INC
                        ON TIPO.CDOPERINCLUSAO = INC.CDOPERADOR
                        AND TIPO.NRORG = INC.NRORG
                    LEFT JOIN OPERADOR ALT
                        ON TIPO.CDOPERULTATU = ALT.CDOPERADOR
                        AND TIPO.NRORG = ALT.NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getTipoOperacao()
    {

        $sql = "SELECT * FROM TIPOOPERAC
                    WHERE IDENTRSAIDOP = 'S'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getSeriesNFAgrupamento()
    {
        $sql = "SELECT * FROM SERIENF
                    ORDER BY DSSERIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getFilialAgrupamento()
    {
        $sql = "SELECT * FROM FILIAL
                    ORDER BY NMFILIAL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getContratosAgrupamento($parametros)
    {
        $nrtipoorcamento = $parametros['NRTIPOORCAMENTO'];
        $nrparc = $parametros['NRPARCFATURA'];
        $nragrupamento = $parametros['NRAGRUPAMENTO'];

        $sql = "SELECT DISTINCT CONT.IDSITUACAOCONTRATO,
                       CONT.NRSEQCONTRATO,
                       CONT.IDTPCONTRATO,
                       CONT.NRCONTRATOFCT,
                       CONT.NRVERSAOCONTRATO,
                       CONT.CDFILIALORCA,
                       PARC.NMPRINCIPALPARC,
                       CONT.DTINICIOCONTRATO,
                       CONT.DTFIMCONTRATO,
                       CONT.NRORG,
                       PARC.NRPARCNEGOCIO,
                       CONT.IDAGRUPPARC,
                       NEGOCIACAO.NRTIPOORCAMENTO,
                       CONT.DSREFERENCIACONT,
                       MD.NRMOEDA,
                       MD.NMMOEDA
                  FROM FCT_CONTRATO CONT
                  JOIN FCT_NEGOCIACAOCONTRATO NEGOCIACAO
                    ON CONT.NRSEQCONTRATO = NEGOCIACAO.NRSEQCONTRATO
                   AND CONT.NRORG = NEGOCIACAO.NRORG
                  JOIN PARCNEGOCIO PARC
                    ON CONT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                   AND CONT.NRORG = PARC.NRORG
                  LEFT JOIN FCT_MOEDA MD
                    ON CONT.NRMOEDA = MD.NRMOEDA
                 WHERE NEGOCIACAO.NRPARCFATURA = $nrparc
                   AND NEGOCIACAO.NRTIPOORCAMENTO IN ($nrtipoorcamento)
                   AND CONT.IDSITUACAOCONTRATO IN ('P', 'A')
                   AND CONT.NRSEQCONTRATO NOT IN (SELECT NRSEQCONTRATO FROM FCT_RELACAGRUPAMENTOCONT)
                 ORDER BY CONT.NRCONTRATOFCT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getInformacoesGridContratos($parametros)
    {
        $sql = "SELECT AGRUP.IDFATCONTJUNT,
                       AGRUP.NRAGRUPAMENTOCONT,
                       AGRUP.NRAGRUPAMENTO,
                       AGRUP.NRSEQCONTRATO,
                       AGRUP.NRORG,
                       AGRUP.IDATIVO,
                       AGRUP.DTINCLUSAO,
                       AGRUP.DTULTATU,
                       AGRUP.NRORGINCLUSAO,
                       AGRUP.CDOPERINCLUSAO,
                       AGRUP.NRORGULTATU,
                       AGRUP.CDOPERULTATU,
                       CONT.NRCONTRATOFCT,
                       CONT.NRPARCNEGOCIO,
                       MD.NRMOEDA,
                       MD.NMMOEDA,
                       TO_CHAR(CONT.DTINICIOCONTRATO, 'DD/MM/YYYY') AS DTINICIOCONTRATO,
                       TO_CHAR(CONT.DTFIMCONTRATO, 'DD/MM/YYYY')    AS DTFIMCONTRATO,
                       PARC.NMPRINCIPALPARC
                  FROM FCT_RELACAGRUPAMENTOCONT AGRUP
             LEFT JOIN FCT_CONTRATO CONT
                    ON AGRUP.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                   AND AGRUP.NRORG = CONT.NRORG
            INNER JOIN PARCNEGOCIO PARC
                    ON CONT.NRPARCNEGOCIO = PARC.NRPARCNEGOCIO
                   AND CONT.NRORG = PARC.NRORG
            LEFT JOIN FCT_MOEDA MD
                    ON CONT.NRMOEDA = MD.NRMOEDA
                 WHERE AGRUP.NRAGRUPAMENTO = '".$parametros['NRAGRUPAMENTO']."'
                   AND AGRUP.NRORG = '".$parametros['NRORG']."'";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    // Retorna os parâmetros de faturamento do escopo
    public function getParametrosFaturamentoEscopo($escopos, $nrorg)
    {
        $sql = "SELECT DISTINCT PFESC.CDTIPOOPERFATURA,
                     PFESC.CDSERIENF,
                     PFESC.CDEMPRESA,
                     PFESC.CDINSCESTA,
                     PFESC.CDINSCMUNI,
                     PFESC.CDFILIALFATURA
                FROM FCT_TIPOORCAMENTO ESCOPO
                LEFT JOIN FCT_CAPAPARAMFATESC PFESC
                  ON ESCOPO.NRTIPOORCAMENTO = PFESC.NRTIPOORCAMENTO
                 AND ESCOPO.NRORG           = PFESC.NRORG
               WHERE ESCOPO.NRTIPOORCAMENTO IN ($escopos)
                 AND ESCOPO.NRORG = $nrorg";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    // Retorna as competências do escopo
    public function getCompetenciasFaturamentoEscopo($escopos, $nrorg)
    {
        $sql = "SELECT DISTINCT NRDIACOMPETINI,
                       NRDIACOMPETFIN,
                       IDMESCOMPETINI,
                       IDMESCOMPETFIN,
                       QTDIASAPURACAO,
                       IDTPCALCVENC,
                       NRDIACALCVENC,
                       IDMESCALCVENC,
                       QTDIASFATUVENC,
                       '_' || LISTAGG(NRTIPOORCAMENTO, '_') WITHIN GROUP(ORDER BY NRTIPOORCAMENTO) || '_' AS NRTIPOORCAMENTO
                   FROM FCT_PARAMFATESC
                  WHERE NRTIPOORCAMENTO IN($escopos)
                    AND NRORG = $nrorg
                  GROUP BY NRDIACOMPETINI,
                         NRDIACOMPETFIN,
                         IDMESCOMPETINI,
                         IDMESCOMPETFIN,
                         QTDIASAPURACAO,
                         IDTPCALCVENC,
                         NRDIACALCVENC,
                         IDMESCALCVENC,
                         QTDIASFATUVENC";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    // Retorna os parâmetros de faturamento dos serviços dos escopos
    public function getParametrosFaturamentoServicoDoEscopo($escopos, $nrorg)
    {
        $sql = "SELECT DISTINCT PFIT.CDTIPOOPERFATURA,
                         PFIT.CDSERIENF,
                         PFIT.CDEMPRESA,
                         PFIT.CDINSCESTA,
                         PFIT.CDINSCMUNI,
                         PFIT.CDFILIALFATURA
                    FROM FCT_TIPOORCAMENTO ESCOPO
                    LEFT JOIN FCT_PARAMFATITESC PFIT
                      ON ESCOPO.NRTIPOORCAMENTO = PFIT.NRTIPOORCAMENTO
                     AND ESCOPO.NRORG           = PFIT.NRORG
                   WHERE ESCOPO.NRTIPOORCAMENTO IN ($escopos)
                     AND ESCOPO.NRORG = $nrorg";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    // Retorna as competências dos serviços dos escopos
    public function getCompetenciasFaturamentoServicoDoEscopo($escopos, $nrorg)
    {
        $sql = "SELECT DISTINCT PFIT.NRDIACOMPETINI,
                       PFIT.NRDIACOMPETFIN,
                       PFIT.IDMESCOMPETINI,
                       PFIT.IDMESCOMPETFIN,
                       PFIT.QTDIASAPURACAO,
                       PFIT.IDTPCALCVENC,
                       PFIT.NRDIACALCVENC,
                       PFIT.IDMESCALCVENC,
                       PFIT.QTDIASFATUVENC,
                       '_' || LISTAGG(NRTIPOORCAMENTO, '_') WITHIN GROUP(ORDER BY NRTIPOORCAMENTO) || '_' AS NRTIPOORCAMENTO
                  FROM FCT_PARAMFATITESCSERV PFIT
            INNER JOIN FCT_ITESCOPOPROPOSTA IT
                    ON PFIT.NRITESCOPOPROPOSTA = IT.NRITESCOPOPROPOSTA
                   AND PFIT.NRORG             = IT.NRORG
                 WHERE IT.NRTIPOORCAMENTO IN($escopos)
                   AND IT.NRORG = $nrorg
              GROUP BY NRDIACOMPETINI,
                     NRDIACOMPETFIN,
                     IDMESCOMPETINI,
                     IDMESCOMPETFIN,
                     QTDIASAPURACAO,
                     IDTPCALCVENC,
                     NRDIACALCVENC,
                     IDMESCALCVENC,
                     QTDIASFATUVENC";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function salvarAgrupamento($parametros)
    {

        $sql = "INSERT INTO FCT_AGRUPAMENTO(NRAGRUPAMENTO, NMAGRUPAMENTO, DSOBSAGRUPAMENTO, NRORG, IDATIVO,
                    DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, CDFILIAL, CDTIPOOPERFATURA, CDSERIENF, CDEMPRESA,
                    CDINSCESTA, CDINSCMUNI, NRPARCFATURA)
                    VALUES(:NRAGRUPAMENTO, :NMAGRUPAMENTO, :DSOBSAGRUPAMENTO, :NRORG, :IDATIVO,
                    SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO, :CDFILIAL, :CDTIPOOPERFATURA, :CDSERIENF, :CDEMPRESA,
                    :CDINSCESTA, :CDINSCMUNI, :NRPARCFATURA)";

        $this->connection->executeStatement($sql, $parametros);
    }

    // Salva os escopos ligados ao agrupamento
    public function salvarEscoposAgrupamento($params)
    {

        $sql = "INSERT INTO FCT_RELACESCOPOAGRUPAMENTO (
                    NRRELACESCAGRUP, NRTIPOORCAMENTO, NRAGRUPAMENTO,
                    NRORG,           NRORGINCLUSAO,   CDOPERINCLUSAO,
                    IDATIVO,         DTINCLUSAO
                ) VALUES (
                    :NRRELACESCAGRUP, :NRTIPOORCAMENTO, :NRAGRUPAMENTO,
                    :NRORG,           :NRORGINCLUSAO,   :CDOPERINCLUSAO,
                    :IDATIVO,         SYSDATE
                )";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateAgrupamento($params)
    {

        $sql = "UPDATE FCT_AGRUPAMENTO
                    SET NMAGRUPAMENTO = :NMAGRUPAMENTO,
                        DSOBSAGRUPAMENTO = :DSOBSAGRUPAMENTO,
                        DTULTATU = SYSDATE,
                        NRORGULTATU = :NRORGULTATU,
                        CDOPERULTATU = :CDOPERULTATU
                    WHERE NRAGRUPAMENTO = :NRAGRUPAMENTO";

        $this->connection->executeStatement($sql, $params);
    }

    //  ------------------------------------------ FUNÇÕES DOS ARQUIVOS FATURAMENTO APURAÇÃO FACTORY

    // Retorna todas as parcelas ligadas a um agrupamento
    public function getParcelasAgrupamentoCont($parametros)
    {

        $nrseqcontrato = $parametros['NRSEQCONTRATO'];
        $nragrupamento = $parametros['NRAGRUPAMENTO'];
        $nrorg = $parametros['NRORG'];

        $sql = "SELECT DISTINCT AGRUPFAT.NRFATURACONT
                  FROM FCT_RELACAGRUPCONTFAT AGRUPFAT
            INNER JOIN FCT_RELACAGRUPAMENTOCONT AGRUPCONT
                    ON AGRUPFAT.NRSEQCONTRATO = AGRUPCONT.NRSEQCONTRATO
                   AND AGRUPFAT.NRORG = AGRUPCONT.NRORG
            INNER JOIN FCT_FATURACONT FAT
                    ON AGRUPFAT.NRFATURACONT = FAT.NRFATURACONT
                   AND AGRUPFAT.NRORG = FAT.NRORG
                 WHERE AGRUPCONT.NRSEQCONTRATO IN($nrseqcontrato)
                   AND AGRUPCONT.NRAGRUPAMENTO = $nragrupamento
                   AND AGRUPFAT.NRORG = $nrorg
                   AND IDSITUACAO = '1'";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getDadosParcela($params)
    {

        $sql = "SELECT FAT.NRFATURACONT,
                       FAT.NRSEQCONTRATO,
                       FAT.NRGRUPOFATURA,
                       FAT.CDFILIALFATURA,
                       FAT.NRPARCFATURA,
                       FAT.IDTPFATURA,
                       FAT.IDSITUACAO,
                       FAT.DTINICOMPET,
                       FAT.DTFINCOMPET,
                       FAT.DTLIMITEAPU,
                       FAT.DTVENCIMENTO,
                       FAT.NRDIASVENCIMENTO,
                       FAT.QTDIASFATUVENC,
                       FAT.VRVENCIMENTO,
                       FAT.VRFATURADO,
                       FAT.VRFALTAFATURAR,
                       FAT.IDFORMAFATURA,
                       FAT.NRAPURACAO,
                       REL.NRMEDICAOFATURA,
                       FAT.DSJUSTIFICATIVA,
                       FAT.IDATIVO,
                       FAT.NRORG,
                       FAT.CDTIPOOPERFATURA,
                       FAT.CDSERIENF,
                       FAT.CDEMPRESA,
                       FAT.CDINSCESTA,
                       FAT.CDINSCMUNI
                  FROM FCT_FATURACONT FAT
                  LEFT JOIN FCT_RELACAGRUPCONTFAT REL
                    ON FAT.NRFATURACONT = REL.NRFATURACONT
                   AND FAT.NRORG        = REL.NRORG
                 WHERE FAT.NRFATURACONT = :NRFATURACONT
                   AND FAT.NRORG        = :NRORG";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }


    // Retorna todos os itens de um contrato determinado em uma parcela

    public function getItemsFatura($parametros)
    {

        $nrfaturacont = $parametros['NRFATURACONT'];
        $nrseqcontrato = $parametros['NRSEQCONTRATO'];
        $nrorg = $parametros['NRORG'];

        $sql = "SELECT NRITFATURACONT, NRFATURACONT, NRSEQCONTRATO, NRITEMOCONTRATO, CDPRODFATURA,
                       IDSITUACAO, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA,
                       NRAPURACAO, NRORG
                  FROM FCT_ITFATURACONT
                 WHERE NRFATURACONT  IN ($nrfaturacont)
                   AND (NRSEQCONTRATO = $nrseqcontrato
                        OR $nrseqcontrato IS NULL)
                   AND NRORG  = $nrorg";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getQuantidadeParcelasContrato($params)
    {

        $sql = "SELECT COUNT(FCT_FATURACONT.NRFATURACONT) AS CONTADOR
                  FROM FCT_FATURACONT
                  JOIN FCT_RELACAGRUPCONTFAT
                    ON FCT_RELACAGRUPCONTFAT.NRFATURACONT = FCT_FATURACONT.NRFATURACONT
                   AND FCT_RELACAGRUPCONTFAT.NRORG        = FCT_FATURACONT.NRORG
                 WHERE FCT_RELACAGRUPCONTFAT.NRSEQCONTRATO = :NRSEQCONTRATO
                   AND FCT_RELACAGRUPCONTFAT.NRORG         = :NRORG
                   AND FCT_FATURACONT.IDTPFATURA           = 'P'";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function insereParcelaDesmembramento($params)
    {

        $sql = "INSERT INTO FCT_FATURACONT
                    (NRFATURACONT, NRSEQCONTRATO, NRGRUPOFATURA, CDFILIALFATURA, NRPARCFATURA, IDTPFATURA,
                     IDSITUACAO, DTINICOMPET, DTFINCOMPET, DTLIMITEAPU, DTVENCIMENTO, NRDIASVENCIMENTO,
                     QTDIASFATUVENC, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA, DSJUSTIFICATIVA,
                     NRAPURACAO, NRMEDICAOFATURA, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO,
                     CDTIPOOPERFATURA, CDSERIENF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, NRPARCELA)
                VALUES
                    (:NRFATURACONT, :NRSEQCONTRATO, :NRGRUPOFATURA, :CDFILIALFATURA, :NRPARCFATURA, :IDTPFATURA,
                     :IDSITUACAO, :DTINICOMPET, :DTFINCOMPET, :DTLIMITEAPU, :DTVENCIMENTO, :NRDIASVENCIMENTO,
                     :QTDIASFATUVENC, :VRVENCIMENTO, :VRFATURADO, :VRFALTAFATURAR, :IDFORMAFATURA, :DSJUSTIFICATIVA,
                     :NRAPURACAO, :NRMEDICAOFATURA, 'S', :NRORG, SYSDATE, :NRORG, :OPERADOR, :CDTIPOOPERFATURA, :CDSERIENF,
                     :CDEMPRESA, :CDINSCESTA, :CDINSCMUNI, :NRPARCELA)";

        $this->connection->executeStatement($sql, $params);
    }

    /**
     * Retorna as informações dos relacionamentos da parcela com o contrato e com a
     * medição
    **/
    public function getInformacoesRelacParcelaCont($nrfaturacont, array $params)
    {

        $sql = "SELECT NRSEQCONTRATO,
                    NRMEDICAOFATURA
                FROM FCT_RELACAGRUPCONTFAT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = :NRORG
                    AND (NRSEQCONTRATO = :NRSEQCONTRATO OR :NRSEQCONTRATO IS NULL)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    // Cria um novo relacionamento da parcela com o contrato
    public function salvarRelacAgrupContFat($params)
    {

        $sql = "INSERT INTO FCT_RELACAGRUPCONTFAT(
                    NRAGRUPCONTFAT,   IDPARCAGRUP,  NRSEQCONTRATO,  NRORG,
                    DTINCLUSAO,       DTULTATU,     NRORGINCLUSAO,  CDOPERINCLUSAO,
                    NRORGULTATU,      CDOPERULTATU, NRFATURACONT,   NRMEDICAOFATURA,
                    IDATIVO
                ) VALUES (
                    :NRAGRUPCONTFAT,  :IDPARCAGRUP,  :NRSEQCONTRATO,  :NRORG,
                    SYSDATE,          NULL,          :NRORG,          :OPERADOR,
                    :NRORG,           :OPERADOR,     :NRFATURACONT,   :NRMEDICAOFATURA,
                    'S'
                )";

        $this->connection->executeStatement($sql, $params);
    }

     // Deleta o relacionamento de parcelas na tabela fct_relaagrupcontfat
    public function deletarRelacAgrupamentoContFat($nrfaturacont, array $params)
    {

        $sql = "DELETE FROM FCT_RELACAGRUPCONTFAT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = :NRORG
                    AND (NRSEQCONTRATO = :NRSEQCONTRATO
                            OR :NRSEQCONTRATO IS NULL)";

        $this->connection->executeStatement($sql, $params);
    }

    public function insereItemDesmembramento(array $params)
    {
        $sql = "INSERT INTO FCT_ITFATURACONT
                   (NRITFATURACONT, NRFATURACONT, NRSEQCONTRATO, NRITEMOCONTRATO, CDPRODFATURA,
                    IDSITUACAO, VRVENCIMENTO, VRFATURADO, VRFALTAFATURAR, IDFORMAFATURA,
                    DSJUSTIFICATIVA, NRAPURACAO, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                VALUES
                   (:NRITFATURACONT, :NRFATURACONT, :NRSEQCONTRATO, :NRITEMOCONTRATO, :CDPRODFATURA,
                    :IDSITUACAO, :VRVENCIMENTO, :VRFATURADO, :VRFALTAFATURAR, :IDFORMAFATURA,
                    :DSJUSTIFICATIVA, :NRAPURACAO, 'S', :NRORG, SYSDATE, :NRORG, :OPERADOR)";

        $this->connection->executeStatement($sql, $params);
    }

     // Deleta as parcelas
    public function deletarParcelaFatura($nrfaturacont, $nrorg)
    {

        $sql = "DELETE FROM FCT_FATURACONT
                WHERE NRFATURACONT IN($nrfaturacont)
                    AND NRORG = $nrorg";

        $this->connection->executeStatement($sql);
    }

    /**
     * Caso a parcela esteja ligada a apenas 1 contrato no final do agrupamento
     * muda o status para parcela normal
    **/
    public function alterarInfoAgrupamentoParcela($params)
    {

        $sql = "UPDATE FCT_RELACAGRUPCONTFAT
                SET IDPARCAGRUP  = 'N',
                    CDOPERULTATU = :CDOPERADOR
                WHERE NRFATURACONT  = :NRFATURACONT
                   AND NRORG        = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function atualizaValorParcelaOrigem(array $params)
    {
        $sql = "UPDATE FCT_FATURACONT
                   SET VRVENCIMENTO   = VRVENCIMENTO - :VRVENCIMENTO,
                       VRFALTAFATURAR = VRFALTAFATURAR - :VRVENCIMENTO,
                       DSJUSTIFICATIVA = :DSJUSTIFICATIVA
                 WHERE NRFATURACONT = :NRFATURACONT
                   AND NRORG        = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    public function deletaItemParcelaOrigem(array $params)
    {
        $sql = "DELETE FROM FCT_ITFATURACONT
                 WHERE (NRITFATURACONT = :NRITFATURACONT
                        OR :NRITFATURACONT IS NULL)
                   AND NRFATURACONT = :NRFATURACONT
                   AND (NRSEQCONTRATO = :NRSEQCONTRATO
                        OR :NRSEQCONTRATO IS NULL)
                   AND NRORG = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    // Deleta o contrato do agrupamento
    public function deletarContratoAgrupamento($parametros)
    {

        $nrseqcontrato = $parametros['NRSEQCONTRATO'];
        $nragrupamento = $parametros['NRAGRUPAMENTO'];
        $nrorg = $parametros['NRORG'];

        $sql = "DELETE FROM FCT_RELACAGRUPAMENTOCONT
                WHERE NRSEQCONTRATO IN($nrseqcontrato)
                    AND NRAGRUPAMENTO = $nragrupamento
                    AND NRORG         = $nrorg";


        $this->connection->executeStatement($sql);
    }

    // Retorna um array com os numeros de contratos de um determinado agrupamento
    public function getQtdContratosAgrupamento(array $params)
    {
        $sql = "SELECT LISTAGG(NRSEQCONTRATO, ',') WITHIN GROUP (ORDER BY NRSEQCONTRATO) AS NRSEQCONTRATO
                  FROM FCT_RELACAGRUPAMENTOCONT
                 WHERE NRAGRUPAMENTO = :NRAGRUPAMENTO
                   AND NRORG         = :NRORG";
        
        $dataset = $this->connection->executeQuery($sql, $params)->fetchAllAssociative();

        if (isset($dataset) && count($dataset) > 0 && $dataset[0]["NRSEQCONTRATO"] != "") {
            return explode(",", $dataset[0]["NRSEQCONTRATO"]);
        }
        return [];
    }

    // Deleta o escopos do agrupamento
    public function deletarEscoposAgrupamento($params)
    {

        $sql = "DELETE FROM FCT_RELACESCOPOAGRUPAMENTO
                WHERE NRAGRUPAMENTO = :NRAGRUPAMENTO
                    AND NRORG         = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }

    // Deleta o agrupamento
    public function deletarAgrupamento($params)
    {

        $sql = "DELETE FROM FCT_AGRUPAMENTO
                WHERE NRAGRUPAMENTO = :NRAGRUPAMENTO
                    AND NRORG         = :NRORG";

        $this->connection->executeStatement($sql, $params);
    }
  // --------------------------------------------------------

    public function validarContratosAprovados($parametros)
    {

            $nrseqcontrato = $parametros['NRSEQCONTRATO'];

            $sql = "SELECT NRCONTRATOFCT, NRSEQCONTRATO
                    FROM FCT_CONTRATO
                    WHERE NRSEQCONTRATO IN ($nrseqcontrato)
                    AND IDSITUACAOCONTRATO = 'A'";

        return $this->connection->executeQuery($sql)->fetchAllAssociative();
    }

    public function getParametrosFatContratos($nrseqcontratos, $params)
    {
            $sql = "SELECT DISTINCT ITNEGO.NRPARCFATURA
                    FROM FCT_ITNEGOCIACAOCONTRATO ITNEGO
                    JOIN FCT_NEGOCIACAOCONTRATO NEGOCIACAO
                        ON ITNEGO.NRNEGOCIACAOCONTRATO = NEGOCIACAO.NRNEGOCIACAOCONTRATO
                    AND ITNEGO.NRORG                = NEGOCIACAO.NRORG
                    JOIN FCT_CONTRATO CONT
                        ON NEGOCIACAO.NRSEQCONTRATO = CONT.NRSEQCONTRATO
                    AND NEGOCIACAO.NRORG         = CONT.NRORG
                    WHERE CONT.NRSEQCONTRATO IN ($nrseqcontratos)
                        OR CONT.NRSEQCONTRATO IN (SELECT NRSEQCONTRATO
                                                    FROM FCT_RELACAGRUPAMENTOCONT
                                                WHERE NRAGRUPAMENTO = :NRAGRUPAMENTO
                                                    AND NRORG         = :NRORG)
                        AND CONT.NRORG = :NRORG";
            return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }
    
    public function insereContrAgrup($params)
    {
            $sql = "INSERT INTO FCT_RELACAGRUPAMENTOCONT(
                                NRAGRUPAMENTOCONT, NRAGRUPAMENTO, NRSEQCONTRATO, IDFATCONTJUNT, NRORG, IDATIVO,
                                DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
                        VALUES (:NRAGRUPAMENTOCONT, :NRAGRUPAMENTO, :NRSEQCONTRATO, NULL, :NRORG, 'S',
                                SYSDATE, :NRORG, :OPERADOR)";

            $this->connection->executeStatement($sql, $params);
    }
}
