import {
    Http,
    Metadata,
} from '@zeedhi/core';
import {
    Button, DialogService, Form, LoadingService, Modal, ModalService, Select, Tabs, TextInput,
} from '@zeedhi/common';
import { TekGrid } from '@zeedhi/teknisa-components-common';
import { Utilities } from '@/util/Utilities';
import moment, { } from 'moment';

export class Sm00011000TabApuracaoFaturamentoController {
    private headerFooterModal!: Modal;

    public tekgridVisivelApuracao: boolean = true;

    public currentRow: any = {};

    public voltarTekGridApuracao() {
        this.tekgridVisivelApuracao = true;
    }

    get textFrameApuracao() {
        return this.currentRow.NMCONTRATO;
    }

    get formApuracaoVisivel() {
        return !this.tekgridVisivelApuracao;
    }

    public dispararFiltro({ component }: any) {
        const filterButton = Metadata.getInstance<Button>(`${component.name}_filterButton`);
        filterButton.click({} as Event, {} as HTMLElement);
    }

    public abrirFrameApuracao({ row }: any) {
        this.tekgridVisivelApuracao = false;
        this.currentRow = row;
        const tabs = Metadata.getInstance<Tabs>('tabsInformationApuracao');
        tabs.activeTab = 0;
        this.carregarDadosTabApuracaoFaturamento();
    }

    public verificaTabs() {
        const tabs = Metadata.getInstance<Tabs>('tabsInformationApuracao');
        const tabAtiva = tabs.activeTab;
        if (tabs.tabs[tabAtiva].name === 'tab_itens') {
            this.carregarTabItens();
        }

        if (tabs.tabs[tabAtiva].name === 'tab_agrupamentos') {
            this.carregarTabAgrupamentos();
        }
    }

    public carregarDadosTabApuracaoFaturamento() {
        Metadata.getInstance<TextInput>('formDadosContrato-NMCONTRATO').value = this.currentRow.NMCONTRATO;
        Metadata.getInstance<TextInput>('formDadosContrato-NRTIPOORCAMENTO').value = this.currentRow.NMTIPOORCAMENTO;
        const textIDTPFATURA = this.currentRow.IDTPFATURA;
        switch (textIDTPFATURA) {
            case 'A':
                Metadata.getInstance<TextInput>('formDadosContrato-IDTPFATURA').value = 'Periódico (valor de parcela fixo)';
                break;
            case 'X':
                Metadata.getInstance<TextInput>('formDadosContrato-IDTPFATURA').value = 'Periódico (Valor Apurado por Medição)';
                break;
            case 'P':
                Metadata.getInstance<TextInput>('formDadosContrato-IDTPFATURA').value = 'Parcelamento (Quantidade de Parcelas)';
                break;
            default:
                break;
        }
        const textIDSITUACAO = this.currentRow.IDSITUACAO;
        switch (textIDSITUACAO) {
            case '1':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Pendente';
                break;
            case '2':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Apurada';
                break;
            case '3':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Calculada';
                break;
            case '4':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Anulada';
                break;
            case '5':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Paralisada';
                break;
            case '6':
                Metadata.getInstance<TextInput>('formDadosParcela-IDSITUACAO').value = 'Parcialmente Apurada';
                break;
            default:
                break;
        }
        Metadata.getInstance<TextInput>('formDadosParcela-NMPARCFATURA').value = this.currentRow.NMPARCFATURA;
        Metadata.getInstance<TextInput>('formDadosParcela-NRINSCRICAOPARC').value = this.currentRow.NRINSCRICAOPARC;
        Metadata.getInstance<TextInput>('formDadosParcela-NMFANTASIA').value = this.currentRow.NMFANTASIA;
        Metadata.getInstance<TextInput>('formDadosParcela-NRPARCELA').value = this.currentRow.NRPARCELA;
        Metadata.getInstance<TextInput>('formDadosParcela-NMFILIALFATURA').value = this.currentRow.NMFILIALFATURA;
        const dtinicompet = this.currentRow.DTINICOMPET.split(' ')[0];
        const dtfincompet = this.currentRow.DTFINCOMPET.split(' ')[0];
        const dtlimiteapu = this.currentRow.DTLIMITEAPU.split(' ')[0];
        Metadata.getInstance<TextInput>('formDadosParcela-DTINICOMPET').value = dtinicompet;
        Metadata.getInstance<TextInput>('formDadosParcela-DTFINCOMPET').value = dtfincompet;
        Metadata.getInstance<TextInput>('formDadosParcela-DTLIMITEAPU').value = dtlimiteapu;
        const form = Metadata.getInstance<Form>('formDadosParcela');
        form.value['formDadosParcela-VRVENCIMENTO'] = this.currentRow.VRVENCIMENTO;
        form.value['formDadosParcela-VRNEGCONTR'] = this.currentRow.VRNEGCONTR;
        form.value['formDadosParcela-VRFALTAFATURAR'] = this.currentRow.VRFALTAFATURAR;
        form.value['formDadosParcela-VRFATURADO'] = this.currentRow.VRFATURADO;
        Metadata.getInstance<TextInput>('formDadosParcela-NMESTRUTURAM').value = this.currentRow.NMESTRUTURAM;
        Metadata.getInstance<TextInput>('formDadosParcela-NMMUNICIPIOFAT').value = this.currentRow.NMMUNICIPIOFAT;
        Metadata.getInstance<TextInput>('formDadosParcela-CDTRIBPRODPADR').value = this.currentRow.CDTRIBPRODPADR;
        const textIDNATUOPER = this.currentRow.IDNATUOPER;
        switch (textIDNATUOPER) {
            case '01':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '01 - Tributação no Município';
                break;
            case '02':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '02 - Tributação Fora do Município';
                break;
            case '03':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '03 - Isenção';
                break;
            case '04':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '04 - Imune';
                break;
            case '05':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '05 - Exigibilidade Suspensa por Decisão Judicial';
                break;
            case '06':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '06 - Exigibilidade Suspensa por Procedimento Administrativo';
                break;
            case '07':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '07 - Não Incidência';
                break;
            case '08':
                Metadata.getInstance<TextInput>('formDadosParcela-IDNATUOPER').value = '08 - Exportação';
                break;
            default:
                break;
        }
        const textIDFORMAFATURA = this.currentRow.IDFORMAFATURA;
        switch (textIDFORMAFATURA) {
            case 'A':
                Metadata.getInstance<TextInput>('formDadosParcela-IDFORMAFATURA').value = 'Automático';
                break;
            case 'M':
                Metadata.getInstance<TextInput>('formDadosParcela-IDFORMAFATURA').value = 'Manual';
                break;
            default:
                break;
        }
        Metadata.getInstance<TextInput>('formDadosNotaFiscal-NRLANCTONF').value = this.currentRow.NRLANCTONF;
        Metadata.getInstance<TextInput>('formDadosNotaFiscal-NRNOTAFISC').value = this.currentRow.NRNOTAFISC;
        Metadata.getInstance<TextInput>('formDadosNotaFiscal-NMFILIALNF').value = this.currentRow.NMFILIALNF;
        Metadata.getInstance<TextInput>('formDadosNotaFiscal-DTENTRSAID').value = this.currentRow.DTENTRSAID;
        const formNotaFiscal = Metadata.getInstance<Form>('formDadosNotaFiscal');
        formNotaFiscal.value['formDadosNotaFiscal-VRNOTAFISC'] = this.currentRow.VRNOTAFISC;
        Metadata.getInstance<TextInput>('formDadosAdicionais-DSJUSTIFICATIVA').value = this.currentRow.DSJUSTIFICATIVA;
    }

    public carregarTabItens() {
        const nrfaturacont = this.currentRow.NRFATURACONT;
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-itens');
            grid.datasource.setFilter({
                NRFATURACONT: nrfaturacont,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public carregarTabAgrupamentos() {
        const nrfaturacont = this.currentRow.NRFATURACONT;
        try {
            const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-tab-agrupamentos');
            grid.datasource.setFilter({
                NRFATURACONT: nrfaturacont,
            });
        } catch (e) {
            // console.error(e);
        }
    }

    public clickButtonToExpand({ component }: any) {
        const form = Metadata.getInstance<Form>(component.name.split('_')[1]);
        form.isVisible = !form.isVisible;

        component.iconName = (component.iconName === 'mdi-chevron-down') ? 'mdi-chevron-right' : 'mdi-chevron-down';
    }

    public validarAgrupamentoFatMarcados({ event }: any) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        const selectedrows = grid.selectedRows;
        if (grid.selectedRows.length > 0) {
            LoadingService.show();
            Http.post('/validarAgrupamentoFatMarcados', selectedrows)
                .then((retorno) => {
                    if (retorno.data === 'OK') {
                        this.prepararApurarParcelasMarcadas();
                    } else {
                        const erro = retorno.data;
                        DialogService.show({
                            name: 'error-dialog-validacao',
                            type: 'error',
                            title: 'Atenção',
                            text: `Operação bloqueada!<br>Não é possível apurar parcelas ligadas a um agrupamento sem que todos os seus contratos estejam aprovados e suas medições referentes a data de competência sejam realizadas.<br><br>Devem ser verificados os seguintes contratos: <br><br>${erro}`,
                        });
                    }
                }).catch((error) => {
                    Utilities.showErrorMessage(error);
                });
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'É necessário selecionar um registro');
        }
    }

    public prepararApurarParcelasMarcadas() {
        let vencimentos = '_';
        const rateios = null;
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        const selectedrows = grid.selectedRows;
        selectedrows.forEach((contFatura) => {
            if (contFatura.NRFATURACONT != null) {
                vencimentos = `${vencimentos}${contFatura.NRFATURACONT}_`;
            }
        });

        if (vencimentos === '_') {
            vencimentos = 'null';
        }

        this.gerarFaturamentoApuracao(vencimentos, rateios, null, true);
    }

    public gerarFaturamentoApuracao(nrfaturacont: String, nrrateioitfatura: null, nritfaturacont: any, multiplosregistros: boolean) {
        const params = {
            P_NRFATURACONT: nrfaturacont,
            P_NRRATEIOITEMFAT: nrrateioitfatura,
            P_NRITFATURACONT: nritfaturacont,
        };
        const gridApuracao = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/gerarFaturamentoApuracao', params)
            .then(() => {
                if (multiplosregistros) {
                    Utilities.showSuccessMessage();
                    gridApuracao.datasource.get();
                    gridApuracao.selectedRows = [];
                } else {
                    Utilities.showSuccessMessage();
                    gridApuracao.datasource.get();
                    gridApuracao.selectedRows = [];
                    this.voltarTekGridApuracao();
                }
            }).catch(() => {
                if (multiplosregistros) {
                    this.abrirModal();
                } else {
                    Http.get('/getModalErroApuracaoFaturamento')
                        .then((retorno) => {
                            const erro = retorno.data.data[0].DSERRO;
                            DialogService.show({
                                name: 'error-dialog-validacao',
                                type: 'error',
                                title: 'Atenção',
                                text: `Operação bloqueada!<br><br>${erro}`,
                            });
                        });
                }
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public async abrirModal() {
        await this.exibirModal();
        Utilities.showDialogMessage('error', 'Operação bloqueada!', 'Ocorreram erros na realização do processo. As parcelas que não foram apuradas serão exibidas na lista a seguir.');
    }

    public async exibirModal() {
        this.headerFooterModal = await ModalService.createFromJson('sm_00011_000_apuracao_faturamento/modal/sm_00011_000_apuracao_faturamento_modal_erro', true);
        this.headerFooterModal.show();
    }

    public fecharModal() {
        this.headerFooterModal.hide();
        this.headerFooterModal?.destroy();
    }

    public prepararCancelarApuracaoMarcados({ event }: any) {
        event!.preventDefault();
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        const selectedrows = grid.selectedRows;
        if (grid.selectedRows.length > 0) {
            const linhasApuradas = selectedrows.filter((row) => row.IDSITUACAO === '2');
            if (linhasApuradas.length === selectedrows.length) {
                this.showConfirmDialogMessage('Deseja realmente cancelar a apuração as parcelas selecionadas?', linhasApuradas);
            } else if (linhasApuradas.length < selectedrows.length && linhasApuradas.length > 0) {
                this.showConfirmDialogMessage('Deseja realmente cancelar a apuração as parcelas selecionadas?<br><br>Obs: Algumas das parcelas selecionadas não estão com a situação Apurada. Estas parcelas serão desconsideradas.', linhasApuradas);
            } else {
                Utilities.showDialogMessage('warning', 'Operação bloqueada!', 'As parcelas selecionadas não estão apuradas.');
            }
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'É necessário selecionar um registro');
        }
    }

    public showConfirmDialogMessage(text: string, linhasApuradas: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.cancelarFaturamentoApuracaoMarcados(linhasApuradas);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public cancelarFaturamentoApuracaoMarcados(linhasApuradas: any) {
        LoadingService.show();
        let vencimentos = '_';
        let dtInicial;
        let dtFinal;
        linhasApuradas.forEach((rowVencimento: any) => {
            dtInicial = moment(rowVencimento.DTINICOMPET, 'DD/MM/YYYY');
            dtFinal = moment(rowVencimento.DTFINCOMPET, 'DD/MM/YYYY');
            if (rowVencimento.NRFATURACONT != null) {
                vencimentos = `${vencimentos}${rowVencimento.NRFATURACONT}_`;
            }
            if (rowVencimento.DTINICOMPET != null) {
                const dtIniAux = moment(rowVencimento.DTINICOMPET, 'DD/MM/YYYY');
                if (dtInicial != null) {
                    const diffIni = dtIniAux.diff(dtInicial);
                    if (diffIni < 0) {
                        dtInicial = dtIniAux;
                    }
                } else {
                    dtInicial = dtIniAux;
                }
            }
            if (rowVencimento.DTFINCOMPET != null) {
                const dtFinAux = moment(rowVencimento.DTFINCOMPET, 'DD/MM/YYYY');
                if (dtFinal != null) {
                    const diffFin = dtFinAux.diff(dtFinal);
                    if (diffFin > 0) {
                        dtFinal = dtFinAux;
                    }
                } else {
                    dtFinal = dtFinAux;
                }
            }
            dtInicial = dtInicial.format('DD/MM/YYYY');
            dtFinal = dtFinal.format('DD/MM/YYYY');
        });
        const params = {
            P_NRSEQCONTRATO: null,
            P_DATAINI: dtInicial,
            P_DATAFIN: dtFinal,
            P_NRFATURACONT: vencimentos,
            P_NRRATEIOITEMFAT: null,
            P_NRITFATURACONT: null,
        };
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/cancelarFaturamentoApuracao', params)
            .then(() => {
                Utilities.showSuccessMessage();
                grid.datasource.get();
                grid.selectedRows = [];
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public async abrirModalAlterarDataSaida() {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        const selectedrows = grid.selectedRows;
        if (grid.selectedRows.length > 0) {
            const linhasPendentes = selectedrows.filter((row) => row.IDSITUACAO === '1');
            if (linhasPendentes.length === selectedrows.length) {
                Utilities.showDialogMessage('warning', 'Atenção!', 'Não é possível alterar a Data de Saída das notas fiscais de parcelas com situação diferente de Apurada.');
            } else if (linhasPendentes.length < selectedrows.length && linhasPendentes.length > 0) {
                await this.exibirModalAlterarDataSaida();
                Metadata.getInstance<TextInput>('NEWDTSAIDANF').value = moment().format('DD/MM/YYYY');
                Utilities.showDialogMessage('warning', 'Atenção!', 'Não é possível alterar a Data de Saída das notas fiscais de parcelas com situação diferente de Apurada, por isso durante o processo essas parcelas serão ignoradas.');
            } else {
                await this.exibirModalAlterarDataSaida();
                Metadata.getInstance<TextInput>('NEWDTSAIDANF').value = moment().format('DD/MM/YYYY');
            }
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'É necessário selecionar um registro');
        }
    }

    public async exibirModalAlterarDataSaida() {
        this.headerFooterModal = await ModalService.createFromJson('sm_00011_000_apuracao_faturamento/modal/sm_00011_000_apuracao_faturamento_modal_data_saida', true);
        this.headerFooterModal.show();
    }

    public fecharModalAlterarDataSaida() {
        this.headerFooterModal.hide();
        this.headerFooterModal?.destroy();
    }

    public validarAgrupamento() {
        if (this.currentRow.IDSITUACAO === '1') {
            const dtinicompet = this.currentRow.DTINICOMPET.split(' ')[0];
            const dtfincompet = this.currentRow.DTFINCOMPET.split(' ')[0];
            const params = {
                NRSEQCONTRATO: `_${this.currentRow.NRSEQCONTRATO}_`,
                NRPARCFATURA: this.currentRow.NRPARCFATURA,
                NRCONTRATOFCT: this.currentRow.NRCONTRATOFCT,
                NRFATURACONT: this.currentRow.NRFATURACONT,
                DTINICIO: dtinicompet,
                DTFIM: dtfincompet,
            };
            LoadingService.show();
            Http.post('/validarAgrupamentoFat', params)
                .then((retorno) => {
                    if (retorno.data || retorno.data.lenght === 0) {
                        this.prepararApurarParcelas(this.currentRow);
                    } else {
                        let contratos = '';
                        const agrupamento = retorno.data;
                        agrupamento.forEach((contrato: any) => {
                            contratos += `-${contrato.NRCONTRATOFCT}<br>`;
                        });
                        DialogService.show({
                            name: 'error-dialog-validacao',
                            type: 'error',
                            title: 'Atenção',
                            text: `Operação bloqueada!<br>Não é possível apurar parcelas ligadas a um agrupamento sem que todos os seus contratos estejam aprovados e suas medições referentes a data de competência sejam realizadas.<br><br>Devem ser verificados os seguintes contratos: <br><br>${contratos}`,
                        });
                    }
                }).catch((error) => {
                    Utilities.showErrorMessage(error);
                });
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'Esta ação só é possível em registro com a situação Pendente');
        }
    }

    public prepararApurarParcelas(currentRow: any) {
        if (currentRow.VRVENCIMENTO === 0) {
            this.showConfirmDialogMessageApurarParcelasForm('Não é possível apurar parcelas com valor zerado.<br><br>Deseja alterar a situação desta parcela para \'Faturada\'?', currentRow);
        } else {
            const nritfaturacont = null;
            const rateios = null;
            const vencimentos = `_${currentRow.NRFATURACONT}_`;
            this.gerarFaturamentoApuracao(vencimentos, rateios, nritfaturacont, false);
        }
    }

    public showConfirmDialogMessageApurarParcelasForm(text: string, currentRow: any) {
        DialogService.show({
            name: 'error_dialog',
            type: 'error',
            title: 'Operação bloqueada!',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.alterarStatusParcelasZeradas(currentRow);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public alterarStatusParcelasZeradas(currentRow: any) {
        const params = {
            NRFATURACONT: currentRow.NRFATURACONT,
            IDSITUACAO: currentRow.IDSITUACAO = '3',
        };
        LoadingService.show();
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/alterarStatusParcelasZeradas', params)
            .then(() => {
                Utilities.showSuccessMessage();
                grid.reload();
                grid.datasource.get();
                this.voltarTekGridApuracao();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public validarCancelamentoAnulamentoParcela() {
        if (this.currentRow.IDSITUACAO === '1') {
            this.abrirModalAnularParcela();
        } else {
            this.showConfirmDialogMessageCancelarParcela('Deseja realmente cancelar a apuração da parcela?', this.currentRow);
        }
    }

    public showConfirmDialogMessageCancelarParcela(text: string, currentRow: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            LoadingService.show();
                            this.cancelarFaturamentoApuracao(currentRow);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public cancelarFaturamentoApuracao(currentRow: any) {
        LoadingService.show();
        const contratos = `_${currentRow.NRSEQCONTRATO}_`;
        const vencimentos = `_${currentRow.NRFATURACONT}_`;
        const dtInicial = currentRow.DTINICOMPET.split(' ')[0];
        const dtFinal = currentRow.DTFINCOMPET.split(' ')[0];
        const rateios = null;
        const nritfaturacont = null;
        const params = {
            P_NRSEQCONTRATO: contratos,
            P_DATAINI: dtInicial,
            P_DATAFIN: dtFinal,
            P_NRFATURACONT: vencimentos,
            P_NRRATEIOITEMFAT: rateios,
            P_NRITFATURACONT: nritfaturacont,
        };
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/cancelarFaturamentoApuracao', params)
            .then(() => {
                this.voltarTekGridApuracao();
                grid.cancelEditedRows();
                grid.reload();
                Utilities.showSuccessMessage();
                grid.datasource.get();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public async abrirModalAnularParcela() {
        await this.exibirModalAnularParcela();
    }

    public async exibirModalAnularParcela() {
        this.headerFooterModal = await ModalService.createFromJson('sm_00011_000_apuracao_faturamento/modal/sm_00011_000_apuracao_faturamento_modal_anular_parcela', true);
        this.headerFooterModal.show();
    }

    public fecharModalAnularParcela() {
        this.headerFooterModal.hide();
        this.headerFooterModal?.destroy();
    }

    public validaQtItens() {
        if (this.currentRow.IDSITUACAO === '1') {
            const params = {
                NRFATURACONT: this.currentRow.NRFATURACONT,
                NRSEQCONTRATO: this.currentRow.NRSEQCONTRATO,
            };
            Http.post('/validaQtItens', params)
                .then((response) => {
                    if (response.data === 'OK') {
                        this.abrirModalDesmembrarParcelas();
                    } else {
                        Utilities.showDialogMessage('error', 'Operação bloqueada!', 'Só é permitido desmembrar parcelas que possuem dois ou mais itens.');
                    }
                }).catch((error) => {
                    Utilities.showErrorMessage(error);
                });
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'Esta ação só é possível em registro com a situação Pendente');
        }
    }

    public async abrirModalDesmembrarParcelas() {
        await this.exibirModalDesmembrarParcelas();
    }

    public async exibirModalDesmembrarParcelas() {
        this.headerFooterModal = await ModalService.createFromJson('sm_00011_000_apuracao_faturamento/modal/sm_00011_000_apuracao_faturamento_modal_desmembrar_parcela', true);
        this.headerFooterModal.show();
    }

    public fecharModalDesmembrarParcelas() {
        this.headerFooterModal.hide();
        this.headerFooterModal?.destroy();
    }

    public setFilterDesmembrarParcela({ component }: any) {
        const nrfaturacont = this.currentRow.NRFATURACONT;
        try {
            component.datasource.setFilter({
                NRFATURACONT: nrfaturacont,
            });
        } catch (e) {
            console.error(e);
        }
    }

    public saveDesmebr() {
        const form = Metadata.getInstance<Form>('formDesmembrarParcela');
        if (Utilities.validateForm(form)) {
            const dsjustificativa = Metadata.getInstance<TextInput>('DSJUSTIFICATIVA').value;
            const hora = moment().format('DD/MM/YYYY HH:mm:ss');
            const justificativa = `${hora}-> A parcela foi vinculada a um faturamento manual pelo seguinte motivo: ${dsjustificativa}`;
            const params = {
                ITDESMEMBRAMENTO: Metadata.getInstance<Select>('ITDESMEMBRAMENTO').value,
                IDFORMADESMEMBAMENTO: Metadata.getInstance<Select>('IDFORMADESMEMBAMENTO').value,
                DSJUSTIFICATIVA: justificativa,
                NRFATURACONT: this.currentRow.NRFATURACONT,
                NRSEQCONTRATO: this.currentRow.NRSEQCONTRATO,
            };
            this.showConfirmDialogMessageDesmembrarParcela('Deseja realmente desmembrar a parcela?', params);
        }
    }

    public showConfirmDialogMessageDesmembrarParcela(text: string, params: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            LoadingService.show();
                            this.desmembrarParcela(params);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public desmembrarParcela(params: any) {
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/desmembrarParcela', params)
            .then(() => {
                this.fecharModalDesmembrarParcelas();
                this.voltarTekGridApuracao();
                grid.cancelEditedRows();
                grid.reload();
                Utilities.showSuccessMessage();
                grid.datasource.get();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public salvarAnularParcela() {
        const form = Metadata.getInstance<Form>('formAnularParcela');
        if (Utilities.validateForm(form)) {
            const dsjustificativa = Metadata.getInstance<TextInput>('DSJUSTIFICATIVA').value;
            this.showConfirmDialogMessageAnularParcela('Deseja realmente Anular a apuração da parcela?', dsjustificativa);
        }
    }

    public showConfirmDialogMessageAnularParcela(text: string, dsjustificativa: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            LoadingService.show();
                            this.anularApuracao(dsjustificativa);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public anularApuracao(dsjustificativa: any) {
        const hora = moment().format('DD/MM/YYYY HH:mm:ss');
        const justificativa = `${hora} -> A parcela foi anulada pelo seguinte motivo: ${dsjustificativa}`;
        const nrfaturacont = this.currentRow.NRFATURACONT;
        const nrseqcontrato = this.currentRow.NRSEQCONTRATO;
        const params = {
            DSJUSTIFICATIVA: justificativa,
            NRFATURACONT: nrfaturacont,
            NRSEQCONTRATO: nrseqcontrato,
        };
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/anularApuracao', params)
            .then(() => {
                this.fecharModalAnularParcela();
                this.voltarTekGridApuracao();
                grid.cancelEditedRows();
                grid.reload();
                Utilities.showSuccessMessage();
                grid.datasource.get();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public showConfirmDialogMessageDataSaida(text: string, linhasApuradas: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            LoadingService.show();
                            this.salvarAlteracaoDataDeSaida(linhasApuradas);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public salvarAlteracaoDataDeSaida(linhasApuradas: any) {
        let nrlanctonf;
        let cdfilial;
        const novaDataSaida = moment(Metadata.getInstance<TextInput>('NEWDTSAIDANF').value, 'DD/MM/YYYY');
        const params: any = {
            DATA: novaDataSaida.format('DD/MM/YYYY'),
            NF: [],
        };
        linhasApuradas.forEach((rowVencimento: any) => {
            nrlanctonf = rowVencimento.NRLANCTONF;
            cdfilial = rowVencimento.CDFILIALNF;
            params.NF.push({
                NRLANCTONF: nrlanctonf,
                CDFILIALNF: cdfilial,
            });
        });
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/alterarDataSaidaDaNotaFiscal', params)
            .then(() => {
                this.fecharModalAlterarDataSaida();
                grid.datasource.get();
                grid.selectedRows = [];
                Utilities.showSuccessMessage();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }

    public validarAlteracaoDataDeSaida() {
        const dataAtual = moment();
        const novaDataSaida = moment(Metadata.getInstance<TextInput>('NEWDTSAIDANF').value, 'DD/MM/YYYY');
        const form = Metadata.getInstance<Form>('formDataSaida');
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        const selectedrows = grid.selectedRows;

        if (dataAtual > novaDataSaida) {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'A nova data de saída definida deve ser igual ou maior que a data atual.');
            Metadata.getInstance<TextInput>('NEWDTSAIDANF').value = dataAtual.format('DD/MM/YYYY');
        }
        if (Utilities.validateForm(form)) {
            const linhasApuradas = selectedrows.filter((row) => row.IDSITUACAO === '2');
            this.showConfirmDialogMessageDataSaida('A alteração da data de saída de uma nota fiscal a retornará para o status Em Digitação.Deseja continuar?', linhasApuradas);
        }
    }

    public validarFatuManual() {
        if (this.currentRow.IDSITUACAO === '1') {
            this.abrirModalFatuManual();
        } else {
            Utilities.showDialogMessage('error', 'Operação bloqueada!', 'Esta ação só é possível em registro com a situação Pendente');
        }
    }

    public async abrirModalFatuManual() {
        await this.exibirModalFatuManual();
    }

    public async exibirModalFatuManual() {
        this.headerFooterModal = await ModalService.createFromJson('sm_00011_000_apuracao_faturamento/modal/sm_00011_000_apuracao_faturamento_modal_fatu_anual', true);
        this.headerFooterModal.show();
    }

    public fecharModalFatuManual() {
        this.headerFooterModal.hide();
        this.headerFooterModal?.destroy();
    }

    public setFilterFatuManual({ component }: any) {
        const nrparcnegocio = this.currentRow.NRPARCFATURA;
        try {
            component.datasource.setFilter({
                NRPARCNEGOCIO: nrparcnegocio,
            });
        } catch (e) {
            console.error(e);
        }
    }

    public setModalFatuManual({ component }: any) {
        const nrnotafisc = component.value;
        component.datasource.data.forEach((dados: any) => {
            if (dados.NRNOTAFISC === nrnotafisc) {
                const dtemissao = dados.DTEMISSAO.split(' ')[0];
                Metadata.getInstance<TextInput>('DTEMISSAO').value = dtemissao;
                Metadata.getInstance<TextInput>('NMFILIAL').value = dados.NMFILIAL;
                Metadata.getInstance<TextInput>('NRLANCTONF').value = dados.NRLANCTONF;
                Metadata.getInstance<TextInput>('CDFILIAL').value = dados.CDFILIAL;
                Metadata.getInstance<TextInput>('CDEMPRESA').value = dados.CDEMPRESA;
                Metadata.getInstance<TextInput>('VRNOTAFISC').value = dados.VRNOTAFISC;
            }
        });
    }

    public validateFatuManual() {
        const form = Metadata.getInstance<Form>('formFatuManual');
        if (Utilities.validateForm(form)) {
            const params = {
                nrnotafisc: Metadata.getInstance<Select>('NRNOTAFISC').value,
                dtemissao: Metadata.getInstance<TextInput>('DTEMISSAO').value,
                nmfilial: Metadata.getInstance<TextInput>('NMFILIAL').value,
                nrlanctonf: Metadata.getInstance<TextInput>('NRLANCTONF').value,
                cdfilial: Metadata.getInstance<TextInput>('CDFILIAL').value,
                cdempresa: Metadata.getInstance<TextInput>('CDEMPRESA').value,
                vrnotafisc: Metadata.getInstance<TextInput>('VRNOTAFISC').value,
                dsjustificativa: Metadata.getInstance<TextInput>('DSJUSTIFICATIVA').value,
            };
            const paramsValidate = {
                nrlanctonf: Metadata.getInstance<TextInput>('NRLANCTONF').value,
                cdfilial: Metadata.getInstance<TextInput>('CDFILIAL').value,
            };
            let message = 'Deseja realmente vincular um faturamento manual a parcela?';
            Http.post('/invoiceValidateHasAlreadyBeenUsed', paramsValidate)
                .then((validate) => {
                    if (validate.data.length > 0) {
                        let messageValidate = 'Atenção!<BR>Essa nota fiscal já esta vinculada a outra(s) parcela(s) :<BR><BR>';
                        validate.data.forEach((faturamento: any) => {
                            messageValidate += `${faturamento.MESSAGE}<BR>`;
                        });
                        message = `${messageValidate}<BR>${message}`;
                        this.showConfirmDialogMessageFatuManual(message, params);
                    }
                    this.showConfirmDialogMessageFatuManual(message, params);
                }).catch((error) => {
                    Utilities.showErrorMessage(error);
                });
        }
    }

    public showConfirmDialogMessageFatuManual(text: string, params: any) {
        DialogService.show({
            name: 'warning_dialog',
            type: 'warning',
            title: 'Confirmação',
            text,
            buttons: [
                {
                    name: 'button-no',
                    component: 'ZdButton',
                    label: 'Não',
                    events: {
                        click: () => DialogService.hide(),
                    },
                    outline: true,
                },
                {
                    name: 'button-yes',
                    component: 'ZdButton',
                    label: 'Sim',
                    events: {
                        click: () => {
                            this.FatuManual(params);
                            DialogService.hide();
                        },
                    },
                },
            ],
        });
    }

    public FatuManual(params: any) {
        LoadingService.show();
        const hora = moment().format('DD/MM/YYYY HH:mm:ss');
        const justificativa = `${hora}-> A parcela foi vinculada a um faturamento manual pelo seguinte motivo: ${params.dsjustificativa}`;
        const dataParams = {
            NRFATURACONT: this.currentRow.NRFATURACONT,
            NRSEQCONTRATO: this.currentRow.NRSEQCONTRATO,
            NRPARCFATURA: this.currentRow.NRPARCFATURA,
            VRVENCIMENTO: this.currentRow.VRVENCIMENTO,
            DSJUSTIFICATIVA: justificativa,
            NRLANCTONF: params.nrlanctonf,
            CDFILIAL: params.cdfilial,
            CDEMPRESA: params.cdempresa,
            VRNOTAFISC: params.vrnotafisc,
        };
        const grid = Metadata.getInstance<TekGrid>('basic-tek-grid-apuracao-faturamento');
        Http.post('/fatuManual', dataParams)
            .then(() => {
                this.fecharModalFatuManual();
                this.voltarTekGridApuracao();
                grid.cancelEditedRows();
                grid.reload();
                Utilities.showSuccessMessage();
                grid.datasource.get();
            }).catch((error) => {
                Utilities.showErrorMessage(error);
            }).finally(() => {
                LoadingService.hide();
            });
    }
}
